#!/usr/bin/env python

from heapq import heappush, heappop

class PriorityQueue:
    
    def __init__(self):
        self.queue = []
        self.n = 0
    
    def put(self, item):
        self.n += 1
        return heappush(self.queue, item)
    
    def get(self):
        self.n -= 1
        assert(self.n >= 0)
        return heappop(self.queue)

    def empty(self):
        return self.n == 0

    def size(self):
        return self.n

    def __str__(self):
        s = ""
        for i in self.queue:
            s += "%s:%s " % (i)
        return s.strip()

def test():
    pq = PriorityQueue()
    pq.put((5, 'c'))
    pq.put((3, 'b'))
    pq.put((7, 'e'))
    pq.put((2, 'a'))
    pq.put((6, 'd'))

    print pq
    
    while not pq.empty():
        print pq.get()
        

if __name__ == "__main__":
    test()
